
local Sponge = {}

local sVer = "1.0.6"

local Sponge_Defaults = {
			a_UpdateInterval	=	0.1;
			a_LockedFrames	=	false;
	}
	
local SpongeSpells = {
		--Death Knight
		48707,		-- Anti-Magic Shell
		77535,		-- Blood Shield (Mastery, Blood)
		--Demon Hunter
		227225,		-- Soul Barrier
		--Druid
		--Hunter
		--Mage
		11426,		-- Ice Barrier (Talent)
		--198094,		-- Ice Barrier (Talent)
		--Monk
		115295,		-- Guard (Brewmaster)
		116849,		-- Life Cocoon (Mistweaver)
		--Paladin
		65148,		-- Sacred Shield (Talent)
		157047,		-- Saved by the Light (Talent, Holy)
		86273,		-- Illuminated Healing (Mastery, Holy)
		--Priest
		17,			-- PowerWord:Shield
		123258,		-- PowerWord:Shield (Discipline)
		47753,		-- Divine Aegis (Discipline)
		114908,		-- Spirit Shell (Discipline)wwwww
		114214,		-- Angelic Bulwark (Talent)
		152118,		-- Clarity of Will (Discipline)
		--18350,		-- Angelic Bulwark (Talent)
		--Rogue
		--Shaman
		114893,		-- Stone Bulwark (Talent)
		--Warlock
		108366,		-- Soul Leech (Talent)
		108416,		-- Sacrificial Pact (Talent)
		--Warrior
		--112048,		-- Shield Barrier (Protection)
		190456,		-- Ignore Pain (Protection)
		--Item
		173260,		-- Shieldtronic Shield
		269279,		-- Resounding Shield 1
		270568,		-- Resounding Shield 2
		263962		-- Resounding Shield 3
	}

function Absorbent_OnLoad(Frame)
	Frame:RegisterForDrag("LeftButton")
	Frame:RegisterEvent("PLAYER_LOGIN")
	Frame:RegisterEvent("ADDON_LOADED");
	Frame:RegisterEvent("PLAYER_LOGOUT");
	
	
		if SpongeDB == nil then
			Sponge = Sponge_Defaults
		else
			Sponge = SpongeDB
		end
		SetVariables()
	

-------------------------------
--Default values
	--if (spongeDB == nil) then 
	--	spongeDB = Sponge_Defaults
	--end
end

function comma_value(n) -- credit http://richard.warburton.it
	local left,num,right = string.match(n,'^([^%d]*%d)(%d*)(.-)$')
	return left..(num:reverse():gsub('(%d%d%d)','%1,'):reverse())..right
end

function LockFrames(v)
	if (v==nil) then
		v = not Sponge.a_LockedFrames;
	end
	if (v==true) then
		print("[Absorbent] Frames unlocked");
	else
		print("[Absorbent] Frames locked");
	end
	Sponge.a_LockedFrames = v
	_G["SpongeFrame"]:EnableMouse(v)
	_G["SpongeFrameTarget"]:EnableMouse(v)
end

function inTable(tbl, item)
    for key, value in pairs(tbl) do
        if value == item then return key end
    end
    return false
end

function inTableVal(tbl, item)
    for key, value in pairs(tbl) do
        if value == item then return key end
    end
    return false
end

function SetVariables()
		for i, v in pairs(Sponge_Defaults) do
		if Sponge[i] == nil then
			Sponge[i] = v;
			end
		end
end
function Absorbent_OnEvent(self, event, ...)
	local timestamp, ttype, hideCaster, srcGUID, srcName, srcFlags, sourceRaidFlags, dstGUID, dstName, dstFlags, destRaidFlags, spellid, spellname, spellschool, targetchan, isGo, OKTOCcontinue, b_or_d = select(1, ...);
	if (event == "ADDON_LOADED") and (timestamp == "Absorbent") then
		LockFrames(Sponge.a_LockedFrames)
	end
	if (event == "PLAYER_LOGIN") then
		print("|cff00ffffAbsorbent ready to absorb!|r (v"..sVer..") /absorb to toggle frame lock");
	end
	if (event == "PLAYER_LOGOUT") then
		SpongeDB = Sponge;
	end
end

function Absorbent_OnUpdate(self, elapsed)
	self.TimeSinceLastUpdate = (self.TimeSinceLastUpdate or 0) + elapsed;
	if (self.TimeSinceLastUpdate > Sponge.a_UpdateInterval) then
		BubbleUpdate("player")
		self.TimeSinceLastUpdate = 0
	end
if(UnitExists("target")) then
	_G["SpongeFrameTarget"]:Show()
else
	_G["SpongeFrameTarget"]:Hide()
end
end


function AbsorbentTarget_OnUpdate(self, elapsed)
if(UnitExists("target")) then
	self.TimeSinceLastUpdate = (self.TimeSinceLastUpdate or 0) + elapsed;
	if (self.TimeSinceLastUpdate > Sponge.a_UpdateInterval) then
		BubbleUpdate("target")
		self.TimeSinceLastUpdate = 0
	end
end
end


function BubbleUpdate(tgt)
	local x,y,z = 0,0,0
	local AuraList = ""
	for i = 1,40 do

		local name, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, nameplateShowPersonal, spellId, canApplyAura, isBossDebuff, nameplateShowAll, timeMod, value1, value2, value3 = UnitBuff(tgt, i)

		if (inTableVal(SpongeSpells,spellId)) then

			z = z+tonumber(value2)

		end
	end
	
		x = UnitHealth(tgt) + z
		y = (z/UnitHealthMax(tgt))*100
			_G[tgt.."SpongeTotal"]:SetText(comma_value(tonumber(z)))
			_G[tgt.."SpongeEHP"]:SetText(comma_value(tonumber(x)))
			_G[tgt.."SpongeEHPPer"]:SetText(tonumber(string.format("%.2f", y)).."%")
end


  SLASH_Absorb1 = '/Absorb'; -- 3.
function SlashCmdList.Absorb(msg, editbox) -- 4.
	LockFrames()
end